<template>
  <div>
    <div style="margin: 3rem 5rem">
      <el-header style="margin-top:10rem">
        <ReturnButton  :offsetArrow="19" :spanTitle="3" title="Regresar" v-on:clickEvent="returnPage" style="margin:0 0 2rem 12rem"></ReturnButton>
        <!-- titulo -->
        <el-col :offset="2" :span="20" class="bg-dark-gray " style="padding:10px 20px">
          <h3 class="text-white">HISTORIAL DE MATERIALES</h3>
        </el-col>
        <div style="position:absolute; top:12.3rem; left:35%">
          <img src="../../../assets/images/hist-enlatados.png" alt="reloj">
        </div>
      </el-header>
      <el-main style="margin: 5rem 8%">
        <el-row style="margin:0 5rem">
          <el-col style="margin: 1rem 0 2.5rem">
            <p>Aquí encontrarás la información del copiado de discos del material fílmico.</p>
            <p>Para buscarlo, ingresa el nombre o código del material que necesitas buscar.</p>
          </el-col>
          <!-- buscador -->
          <el-col>
            <autocomplete 
              @handleSelect="handleSelect" 
              @querySearch="querySearch"  
              @input="eventInput" 
              :text="textSearch"
              placeholderText="Buscar"
              colorOrange='false'></autocomplete>
            <el-button @click="btnSearch" type="primary" style="margin-left: 4rem">BUSCAR</el-button>
          </el-col>
          <el-col>
            <!-- Tarjeta 'No hay resultado' -->
            <el-row style="margin-top:5rem" v-if="noCoincidence">
              <el-col :span="20">
                <!-- <el-card :body-style="{ padding: '0px' }"> -->
                  <el-col :span="6" style="margin-top: 1rem" class="text-center">
                    <img src="../../../assets/images/detective.svg" alt="detective" width="90px">
                  </el-col>
                  <el-col :span="16">
                    <div style="margin-top: 3rem">
                      <p class="subtitle-styles">¡Lo sentimos!</p>
                      <p class="subtitle-styles">No encontramos resultados para tu búsqueda </p>
                    </div>
                  </el-col>
                <!-- </el-card> -->
              </el-col>
            </el-row>
          </el-col>
        </el-row>
      </el-main>
    </div>
  </div>
</template>

<style>
.autocompletado {
  width: 30rem
}
</style>

<script>

import SearchFilter from '@/components/searchFilter.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import autocomplete from '@/components/autocomplete.vue'
import { modifyText } from '../../../utils/modifyText.js'

export default {
  components: {
    ReturnButton,
    autocomplete,
    'app-search-filter': SearchFilter
  },
  data () {
    return {
      links: [],
      textSearch: '',
      idMaterial: '',
      noCoincidence: false
    }
  },
  created () {
    this.getMaterials()
  },
  methods: {
    getMaterials () {
      let dataType = 'materials'
      this.$store.dispatch('getData', dataType)

      let canned = []
      this.$store.state.allMaterials.map((el) => {
        if (el.canned === true && el.listTitle !== null) {
          canned.push(el)
        }
      })
      this.links = canned.filter(m => m.stringMaterialType == 'Enlatado')
    },
    returnPage () {
      this.$router.push({ name: 'cannedMaterials' })
    },
    btnSearch () {
      let idMat = this.idMaterial
      this.$localStorage.set('idRecordCanned', idMat)
      this.$router.push({name: 'historyRecordCanned'})
    },
    querySearch (queryString, cb) {
      var links = this.links
      var results = queryString ? links.filter(this.createFilter(queryString)) : links
      if (results.length === 0) {
        this.noCoincidence = true
      } else {
        this.noCoincidence = false
      }
      cb(results)
    },
    createFilter (queryString) {
      return (link) => {
        return (modifyText(link.listTitle).indexOf(modifyText(queryString)) === 0)
      }
    },
    handleSelect (item) {
      console.log(item, 'itemAutocomplete')
      this.textSearch = item.listTitle
      this.idMaterial = item.__id
      this.$localStorage.set('itemHistory', JSON.stringify(item))

    },
    eventInput (val) {
      if (val === '') {
        this.noCoincidence = false
      }
    }
  }
}
</script>